#include "lcd_init.h"
#include "delay.h"

void LCD_GPIO_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOG|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE, ENABLE);	 //ʹA˿ʱ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;	 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOG, &GPIO_InitStructure);
 	GPIO_SetBits(GPIOG,GPIO_Pin_12);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_15;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;//ٶ50MHz
 	GPIO_Init(GPIOD, &GPIO_InitStructure);
 	GPIO_SetBits(GPIOD,GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_15);

}


/******************************************************************************
      ˵LCDд뺯
      ݣdat  ҪдĴ
      ֵ  
******************************************************************************/
void LCD_Writ_Bus(u8 dat) 
{	
	u8 i;
	LCD_CS_Clr();
	for(i=0;i<8;i++)
	{			  
		LCD_SCLK_Clr();
		if(dat&0x80)
		{
		   LCD_MOSI_Set();
		}
		else
		{
		   LCD_MOSI_Clr();
		}
		LCD_SCLK_Set();
		dat<<=1;
	}	
  LCD_CS_Set();	
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA8(u8 dat)
{
	LCD_Writ_Bus(dat);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_DATA(u16 dat)
{
	LCD_Writ_Bus(dat>>8);
	LCD_Writ_Bus(dat);
}


/******************************************************************************
      ˵LCDд
      ݣdat д
      ֵ  
******************************************************************************/
void LCD_WR_REG(u8 dat)
{
	LCD_DC_Clr();//д
	LCD_Writ_Bus(dat);
	LCD_DC_Set();//д
}


/******************************************************************************
      ˵ʼͽַ
      ݣx1,x2 еʼͽַ
                y1,y2 еʼͽַ
      ֵ  
******************************************************************************/
void LCD_Address_Set(u16 x1,u16 y1,u16 x2,u16 y2)
{
	LCD_WR_REG(0x15);//еַ
	LCD_WR_DATA8(x1);
	LCD_WR_DATA8(x2);
	LCD_WR_REG(0x75);//еַ
	LCD_WR_DATA8(y1);
	LCD_WR_DATA8(y2);
	LCD_WR_REG(0x5c);
}

void LCD_Init(void)
{
	LCD_GPIO_Init();//ʼGPIO
	
	LCD_RES_Clr();//λ
	delay_ms(100);
	LCD_RES_Set();
	delay_ms(100);
	
	LCD_WR_REG(0xFD);
	LCD_WR_DATA8(0x12);
	LCD_WR_REG(0xFD);
	LCD_WR_DATA8(0xB1);
	LCD_WR_REG(0xAE);
	LCD_WR_REG(0xB3);
	LCD_WR_DATA8(0xF1);
	LCD_WR_REG(0xCA);
	LCD_WR_DATA8(0x7F);
	LCD_WR_REG(0xA2);
	LCD_WR_DATA8(0x00);
	LCD_WR_REG(0xA1);
	LCD_WR_DATA8(0x00);
	LCD_WR_REG(0xA0);
	if(USE_HORIZONTAL)
	{
	  LCD_WR_DATA8(0x74);
	}
	else 
	{
		LCD_WR_DATA8(0x66);
	}
	LCD_WR_REG(0xB5);
	LCD_WR_DATA8(0x00);
	LCD_WR_REG(0xAB);
	LCD_WR_DATA8(0x01);
	LCD_WR_REG(0xB4);
	LCD_WR_DATA8(0xA0);
	LCD_WR_DATA8(0xB5);
	LCD_WR_DATA8(0x55);
	LCD_WR_REG(0xC1);
	LCD_WR_DATA8(0xC8);
	LCD_WR_DATA8(0x80);
	LCD_WR_DATA8(0xC8);
	LCD_WR_REG(0xC7);
	LCD_WR_DATA8(0x0F);
	LCD_WR_REG(0xB1);
	LCD_WR_DATA8(0x32);
	LCD_WR_REG(0xBB);
	LCD_WR_DATA8(0x17);
	LCD_WR_REG(0xB2);
	LCD_WR_DATA8(0xA4);
	LCD_WR_DATA8(0x00);
	LCD_WR_DATA8(0x00);
	LCD_WR_REG(0xB6);
	LCD_WR_DATA8(0x01);
	LCD_WR_REG(0xBE);
	LCD_WR_DATA8(0x05);
	LCD_WR_REG(0xA6);
	LCD_WR_REG(0xAF);
}







